#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------
## Daniel Wollschlger <dwoll [at] psychologie.uni-kiel.de>
## Befehle zum Buch "Grundlagen der Datenanalyse mit R" (Springer)
## http://www.uni-kiel.de/psychologie/dwoll/r/
## Stand: 22.07.10
##
## Vgl. Abschnitt 4.1, um die folgenden Befehle auszufhren.
##
## Befehle, die eine Benutzerinteraktion notwendig machen oder
## nicht erwnschte Nebenwirkungen haben, sind auskommentiert.
#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------

####*---------------------------------------------------------------------------
##### 3 Datenstze
#####---------------------------------------------------------------------------

#####---------------------------------------------------------------------------
##### 3.1 Listen
##### 3.1.1
myList1 <- list(c(1, 3), c(12, 8, 29, 5))
length(myList1)
myList1[[2]]
myList1[[2]][3]

(myList2 <- list(1:4, matrix(1:4, 2, 2), c("Lorem", "ipsum")))
myList2[[2]][1, 2]
myList2[[c(3, 2)]]
myList2[[2]]
class(myList2[[2]])
myList2[2]
class(myList2[2])

(myList3 <- list(1:5, 8:4, word="dolor"))
myList3[["word"]]
myList3$word

mat     <- cbind(1:10, sample(-10:10, 10, replace=FALSE))
retList <- cov.wt(mat, method="ML")
names(retList)
retList$cov
retList$center
retList$n.obs

##### 3.1.2
myListAA <- list(AAA=c(1, 2), AAB=c("AAB1", "AAB2", "AAB3"))
myMatAB  <- matrix(1:8, nrow=2)
myListBA <- list(BAA=matrix(rnorm(10), ncol=2), BAB=c("BAB1", "BAB2"))
myVecBB  <- sample(1:10, 5)
myListA  <- list(AA=myListAA, AB=myMatAB)
myListB  <- list(BA=myListBA, BB=myVecBB)
myList4  <- list(A=myListA, B=myListB)
str(myList4)
str(myList4$B)
str(myList4$B$BA)
myList4$B$BA$BAA[4, 2]

myList5 <- list(c(1, 2, 3), c("A", "B"), matrix(5:12, 2))
unlist(myList5)

#####---------------------------------------------------------------------------
##### 3.2 Datenstze
nSubj  <- 12
sex    <- sample(c("f", "m"), nSubj, replace=TRUE)
group  <- sample(rep(c("CG", "WL", "T"), 4), nSubj, replace=FALSE)
age    <- sample(18:35, nSubj, replace=TRUE)
IQ     <- round(rnorm(nSubj, mean=100, sd=15))
rating <- round(runif(nSubj, min=0, max=6))
(myDf1 <- data.frame(id=1:nSubj, sex, group, age, IQ, rating))

## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
dim(myDf1)
nrow(myDf1)
ncol(myDf1)
summary(myDf1)

##### 3.2.1
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
str(myDf1)

fac   <- c("CG", "T1", "T2")
DV1   <- c(14, 22, 18)
DV2   <- c("red", "blue", "blue")
myDf2 <- data.frame(fac, DV1, DV2, stringsAsFactors=FALSE)
str(myDf2)

fac   <- as.factor(fac)
myDf3 <- data.frame(fac, DV1, DV2, stringsAsFactors=FALSE)
str(myDf3)

##### 3.2.2
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
myDf1[[3]][2]
myDf1$rating
myDf1$age[4]
myDf1$IQ[10:12] <- c(99, 110, 89)
myDf1[3, 4]
myDf1[4, 3]
myDf1[2, ]
myDf1[, 4]
myDf1[1:5, 4, drop=FALSE]

##### 3.2.3
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
with(myDf1, tapply(IQ, group, mean))
xtabs(~ sex + group, data=myDf1)
## IQ[3]
attach(myDf1)
IQ[3]
search()[1:4]

IQ[3] <- 130; IQ[3]
myDf1$IQ[3]
detach(myDf1)
## IQ

##### 3.2.4
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
dimnames(myDf1)
names(myDf1)
names(myDf1)[3]
names(myDf1)[3] <- "fac"; names(myDf1)
names(myDf1)[names(myDf1) == "fac"] <- "group"; names(myDf1)

(rows <- paste("Z", 1:12, sep=""))
rownames(myDf1) <- rows; myDf1[1:5, ]

##### 3.2.5
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
isSingle <- sample(c(TRUE, FALSE), nrow(myDf1), replace=TRUE)
myDf2    <- myDf1
myDf2$isSingle1    <- isSingle
myDf2["isSingle2"] <- isSingle
myDf3 <- cbind(myDf1, isSingle); myDf3[1:5, ]
myDf4 <- transform(myDf3, rSq=rating^2); myDf4[1:3, ]

dfTemp          <- myDf1
dfTemp$group    <- NULL; dfTemp[1:5, ]

delVars         <- c("sex", "IQ")
nullList        <- vector("list", length(delVars))
dfTemp[delVars] <- nullList; dfTemp[1:5, ]

##### 3.2.6
##### 3.2.6.1
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
(idxLog <- myDf1$sex == "f")
(idxNum <- which(idxLog))
myDf1[idxNum, ]

(idx2 <- (myDf1$sex == "m") & (myDf1$rating > 2))
myDf1[which(idx2), ]

(idx3 <-    (myDf1$IQ < 90) | (myDf1$IQ > 110))
myDf1[which(idx3), ]

myDf1[1:4, c("group", "IQ")]
myDf1[1:4, 2:4]

dfTemp         <- myDf1
(names(dfTemp) <- paste(rep(c("A", "B"), each=3), 100:102, sep=""))
(colIdx        <- grep("^B.*$", names(dfTemp)))
dfTemp[1:4, colIdx]

##### 3.2.6.2
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
subset(myDf1, sex == "f")
subset(myDf1, sex == "f", select=-2)
subset(myDf1, (myDf1$sex == "m") & (myDf1$rating > 2))
subset(myDf1, (myDf1$IQ   <  90) | (myDf1$IQ     > 110))
subset(myDf1, group %in% c("CG", "WL"))

##### 3.2.7
nSubj  <- 4
vec1   <- sample(1:10, nSubj, replace=TRUE)
vec2   <- sample(1:10, nSubj, replace=TRUE)
vec3   <- sample(1:10, nSubj, replace=TRUE)
dfTemp <- data.frame(cond1=vec1, cond2=vec2, cond3=vec3)

(res   <- stack(dfTemp, select=c("cond1", "cond3")))
str(res)
unstack(res)

res$newIV <- factor(sample(rep(c("A", "B"), c(4, 4)), 8, replace=FALSE))
res$newDV <- sample(100:200, 8)
unstack(res, newDV ~ newIV)

##### 3.2.8
nSubj   <- 2
nGroups <- 2
id      <- 1:(nGroups*nSubj)
group   <- factor(rep(c("A", "B"), nSubj))
DV_t1   <- round(rnorm(nGroups*nSubj, -1, 1), 2)
DV_t2   <- round(rnorm(nGroups*nSubj,  0, 1), 2)
DV_t3   <- round(rnorm(nGroups*nSubj,  1, 1), 2)
(dfWide <- data.frame(id, group, DV_t1, DV_t2, DV_t3))

DVL     <- c(DV_t1, DV_t2, DV_t3)
idL     <- rep(id, 3)
groupL  <- rep(group, 3)
timeFac <- factor(rep(1:3, each=nSubj*nGroups))
dfLong  <- data.frame(id=idL, group=groupL, varTime=timeFac, DV=DVL)
dfLong[order(dfLong$id), ]

resLong <- reshape(dfWide, varying=list(c("DV_t1", "DV_t2", "DV_t3")),
                   direction="long", idvar=c("id", "group"), v.names="DV")
resLong[order(resLong$id), ]
reshape(dfLong, v.names="DV", timevar="varTime", idvar=c("id", "group"),
        direction="wide")

nSubj  <- 4
id     <- 1:nSubj
t_11   <- round(rnorm(nSubj,  8, 2), 2)
t_12   <- round(rnorm(nSubj, 10, 2), 2)
t_21   <- round(rnorm(nSubj, 13, 2), 2)
t_22   <- round(rnorm(nSubj, 15, 2), 2)
t_31   <- round(rnorm(nSubj, 13, 2), 2)
t_32   <- round(rnorm(nSubj, 15, 2), 2)
dfWide <- data.frame(id, t_11, t_12, t_21, t_22, t_31, t_32)

(dfLong1 <- reshape(dfWide,  varying=list(c("t_11", "t_21", "t_31"),
                                          c("t_12", "t_22", "t_32")),
                    direction="long", timevar="IV1", idvar="id",
                    v.names=c("IV2-1", "IV2-2")))

dfLong2  <- reshape(dfLong1, varying=list(c("IV2-1", "IV2-2")),
                    direction="long", timevar="IV2", idvar=c("id", "IV1"),
                    v.names="DV")
head(dfLong2)

##### 3.2.9
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
(splitRes <- split(myDf1, myDf1$group))
myDf1CG   <- splitRes$CG
class(myDf1CG)
(meanIqT  <- mean(splitRes$T$IQ))
(meanIqWL <- mean(splitRes$WL$IQ))
(meanIqCG <- mean(splitRes$CG$IQ))

tapply(myDf1$IQ, myDf1$group, mean)

##### 3.2.10
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
(dfNew <- data.frame(id=13:15, group=c("CG", "WL", "T"), sex=c("f", "f", "m"),
                     age=c(18, 31, 21), IQ=c(116, 101, 99), rating=c(4, 4, 1)))
dfComb <- rbind(myDf1, dfNew); dfComb[11:15, ]

(dfA <- data.frame(id=1:4, initials=c("AB", "CD", "EF", "GH"),
                   IV1=c("-", "-", "+", "+"), DV1=c(10, 10, 11, 14)))
(dfB <- data.frame(id=1:4, initials=c("AB", "CD", "EF", "GH"),
                   IV2=c("A", "B", "A", "B"), DV2=c(91, 89, 92, 79)))

merge(dfA, dfB)
merge(dfA, dfB, by.x=c(TRUE, FALSE, FALSE, FALSE),
                by.y=c(TRUE, FALSE, FALSE, FALSE))

(dfC <- data.frame(id=3:6, initials=c("EF", "GH", "IJ", "KL"),
                   IV2=c("A", "B", "A", "B"), DV2=c(92, 79, 101, 81)))
merge(dfA, dfC)
merge(dfA, dfC, all.y=TRUE)
merge(dfA, dfC, all.x=TRUE, all.y=TRUE)

##### 3.2.11
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
(myList <- lapply(myDf1[ , c(1, 4, 5, 6)], mean))
sapply(myDf1[ , c(1, 4, 5, 6)], range)
sapply(myDf1, is.numeric)
dataNum <- myDf1[ , sapply(myDf1, is.numeric)]; dataNum[1:5, ]

replicate(6, round(rnorm(4), 2))

do.call("c", myList)
work   <- factor(sample(c("home", "office"), 20, replace=TRUE))
hiLo   <- factor(sample(c("hi", "lo"),       20, replace=TRUE))
group  <- factor(sample(c("A", "B"),         20, replace=TRUE))
argLst <- list(fac1=work, fac2=hiLo, fac3=group, row.vars="fac1",
               col.vars=c("fac2", "fac3"))
do.call("ftable", argLst)

##### 3.2.12
x1    <- rnorm(100, 10, 10)
y1    <- rnorm(100, 10, 10)
x2    <- x1 + rnorm(100, 5, 4)
y2    <- y1 + rnorm(100, 10, 4)
myDf2 <- data.frame(cbind(x1, y1))
myDf3 <- data.frame(cbind(x2, y2))
mapply(t.test, myDf2, myDf3, MoreArgs=list(alternative="less", var.equal=TRUE))

##### 3.2.13
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
aggregate(myDf1[ , 4:6], list(myDf1$sex, myDf1$group), mean)
by(myDf1[ , 4:6], list(myDf1$sex, myDf1$group), FUN=mean)

##### 3.2.14
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
myDfDouble <- rbind(myDf1, myDf1[sample(1:nrow(myDf1), 4), ])
duplicated(myDfDouble)
myDfUnique <- unique(myDfDouble)

myDfNA           <- myDf1
myDfNA$IQ[4]     <- NA
myDfNA$rating[5] <- NA

is.na(myDfNA)[1:5, 4:6]
apply(is.na(myDfNA), 2, any)
complete.cases(myDfNA)
subset(myDfNA, !complete.cases(myDfNA))
na.omit(myDfNA)[1:5, ]

##### 3.2.15
## fr Daten des Buches diese Datei laden:
# load("data_myDf1.Rdata")
(idx1 <- order(myDf1$rating))
myDf1[idx1, ]
(idx2 <- order(myDf1$group, myDf1$IQ))
myDf1[idx2, ]

