#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------
## Daniel Wollschlger <dwoll [at] psychologie.uni-kiel.de>
## Befehle zum Buch "Grundlagen der Datenanalyse mit R" (Springer)
## http://www.uni-kiel.de/psychologie/dwoll/r/
## Stand: 22.07.10
##
## Vgl. Abschnitt 4.1, um die folgenden Befehle auszufhren.
#####---------------------------------------------------------------------------
#####---------------------------------------------------------------------------

####*---------------------------------------------------------------------------
##### 5 Hilfsmittel fr die Inferenzstatistik
#####---------------------------------------------------------------------------

#####---------------------------------------------------------------------------
##### 5.1 Formulierung linearer Modelle
Y ~ X1 + X2 + X3
Y ~ X1 - 1
Y ~ X1 + X2 + X1:X2
Y ~ X1*X2
Y ~ X1*X2*X3
Y ~ (X1 + X2 + X3)^2

terms(Y ~ X1*X2*X3)
terms(Y ~ (X1 + X2 + X3)^2 - X1 - X2:X3)

log(Y) ~ abs(X)
Y ~ I(X*2)

#####---------------------------------------------------------------------------
##### 5.2 Funktionen von Zufallsvariablen
##### 5.2.1
dbinom(7, 10, 0.5)
choose(10, 7) * 0.5^7 * (1-0.5)^(10-7)

##### 5.2.2
pbinom(7, size=10, prob=0.5)
sum(dbinom(0:7, size=10, prob=0.5))
pnorm(c(-Inf, 0, Inf), mean=0, sd=1)
pnorm(1.645, mean=0, sd=1, lower.tail=FALSE)
1-pnorm(1.645, mean=0, sd=1, lower.tail=TRUE)
m <- 100
s <- 15
pnorm(m+s, mean=m, sd=s) - pnorm(m-s, mean=m, sd=s)

##### 5.2.3
qnorm(pnorm(0))
qnorm(1-(0.05/2), 0, 1)
qt(1-0.01, 18, 0)

#####---------------------------------------------------------------------------
##### 5.3 Behandlung fehlender Werte in inferenzstatistischen Tests
